import java.awt.*;
import java.util.*;
import java.awt.event.*;
import java.awt.Dimension;
import javax.swing.*;
import javax.swing.event.*;

import tio.*;

public class ColourSpace {
	// Globale variabele om handig bij de input-zin te kunnen (slecht slecht)
	private static String tekst;

	// De kleuren die gebruikt kunnen worden met newColour();
	private static final int BLACK   = 0;
	private static final int RED     = 1;
	private static final int ORANGE  = 2;
	private static final int YELLOW  = 3;
	private static final int GREEN   = 4;
	private static final int BLUE    = 5;
	private static final int MAGENTA = 6;


	// addDrawing() bevat alle if-statements, die bepalen welke vormen/kleuren er getekend worden.
	// Het is zogezegd de parser.
	public static int addDrawing(String inputZin, Vector drawing, PLCanvas canvas, int colorMode) {

		int pressedX, pressedY, releasedX, releasedY;
		Tools tools = new Tools();

// Test om alle kleuren te pakken
/*
colorMode = newColour(drawing, colorMode, BLACK);
colorMode = newColour(drawing, colorMode, RED);
colorMode = newColour(drawing, colorMode, ORANGE);
colorMode = newColour(drawing, colorMode, YELLOW);
colorMode = newColour(drawing, colorMode, GREEN);
colorMode = newColour(drawing, colorMode, BLUE);
colorMode = newColour(drawing, colorMode, MAGENTA);
*/
		tekst = inputZin;

		System.out.println("*****New Sentence*****");

		// Als je bij een woord meerdere lijntjes wilt, moet je alles (_alles_) in de if-statement
		// herhalen. Als je een figuur wilt laten tekenen bij meerdere woorden, moet je meer
		// mogelijkheden in de if() zetten.

		// Love
		if( bevat("heart") || bevat("love") || bevat("adore")
				|| bevat("nice") || bevat("hart") || bevat("lief")
				|| bevat("sweet") || bevat("zoet") || bevat("roze")
				|| bevat("pink") || bevat("cute") || bevat("leuk")
		  ) {
			colorMode = newColour(drawing, colorMode, RED);
			drawHeart(drawing, 0, "Line", 2);
			System.out.println("***kleur: " + colorMode + " :hartje: gevonden");
		}

		// Angry
		if( bevat("angry") || bevat("frustrat") || bevat("piss")
				|| bevat("mad") || bevat("bad") || bevat("horribl")
				|| bevat("aggravat") || bevat("doesn't work") || bevat("boos")
				|| bevat("werkt niet") || bevat("stom") || bevat("achterlijk")
		  ) {
			colorMode = newColour(drawing, colorMode, GREEN);
			drawAngry(drawing, 0, "Line", 10);
			System.out.println("***kleur: " + colorMode + " :boos: gevonden");
		}

		// Happy
		if( bevat("happy") || bevat("bright") || bevat("bounc")
				|| bevat("glad") || bevat("blij") || bevat("zon")
				|| bevat("ecstat") || bevat("thrill") || bevat("geluk")
				|| bevat("sun") || bevat("wonder") || bevat("fantas")
		  ) {
			colorMode = newColour(drawing, colorMode, YELLOW);
			drawHappy(drawing, 0, "Line", 5);
			System.out.println("***kleur: " + colorMode + " :happy: gevonden");
		}

		// Sad
		if( bevat("sad") || bevat("blue") || bevat("verdriet") || bevat("unhapp")
				|| bevat("lone") || bevat("eenzaam") || bevat("solit") 
				|| bevat("whiskey") || bevat("depress") || bevat("grief") 
				|| bevat("hurt") || bevat("pain")
				|| bevat("sorry") 
		) {
			colorMode = newColour(drawing, colorMode, BLUE);
			drawSad(drawing, 0, "Line", 2);
			System.out.println("***kleur: " + colorMode + " :verdriet: gevonden");

		}

		// Nonsense
		if( bevat("lala") || bevat("pom") || bevat("tral")
				|| bevat("leuk") || bevat("lol") || bevat("grap")
				|| bevat("neat") || bevat("fun") || bevat("nonsens")
				|| bevat("useless") || bevat("art") || bevat("joke")
		  ) {
			colorMode = newColour(drawing, colorMode, ORANGE);
			drawNonsense(drawing, 0, "Line", 5);
			System.out.println("***kleur: " + colorMode + " :nonsense: gevonden");
		}

		// Question
		if( bevat("why") || bevat("who") || bevat("waar")
				|| bevat("?") || bevat("snap het niet") || bevat("hoezo")
				|| bevat("moei") || bevat("but") || bevat("wat")
				|| bevat("how") || bevat("wonder") || bevat("what")
		  ) {
			colorMode = newColour(drawing, colorMode, BLACK);
			drawQuestion(drawing, 0, "Line", 2);
			System.out.println("***kleur: " + colorMode + " :question: gevonden");
		}

		// Old test-functions, legacy
		if( bevat("peren") ) {
			colorMode = newColour(drawing, colorMode, GREEN);
			addLine(drawing,400,400,200,200,"Line",5);
			System.out.println("***kleur: " + colorMode + " :peren: gevonden");
		}


		if( bevat("gaat") && bevat("goed") ) {
			colorMode = newColour(drawing, colorMode, MAGENTA);
			addLine(drawing,300,100,200,200,"Line",5);
			addLine(drawing,200,200,100,100,"Line",5);
			System.out.println("***kleur: " + colorMode + " :gaat:goed: gevonden");
		}

		// Add to canvas, to show the result in de GUI
		canvas.setVector(drawing);
		canvas.clear();

		System.out.println(tekst);
		return(colorMode);
		// After return, a new loop is started in main() in Plotter.java
	}



	/* int = newColour(drawing, oldColour, newColour);
	 * newColour voegt een kleurwisseling toe aan de tekening. Daarvoor moet eerst
	 * de oude kleur worden teruggezet (add oldColour) en daarna de nieuwe kleur
	 * worden gepakt (add newColour). De newColour wordt geretourneerd, om uiteindelijk
	 * aan de aanroepende functie in Plotter.java te worden terug gegeven. Dit is nodig
	 * om bij een nieuwe zin de oude kleur nog te weten. Wat weer nodig is omdat anders
	 * de verkeerde kleur teruggezet zou kunnen worden.
	 * Als de nieuwe kleur hetzelfde is als de oude kleur, hoeft er niet van kleur
	 * gewisseld te worden.
	 */
	public static int newColour(Vector drawing, int oldColour, int newColour) {
		// Zelfde kleur? Niet wisselen
		if (oldColour == newColour)
			return( oldColour);
		// Als er uberhaupt nog geen pen is gepakt, wordt de eerste vector
		// overgeslagen in Convert.java, door initialisatie op kleur '9'
		// in Plotter.java Hoeft hier niet meer gecontroleerd.

		// else: Andere kleur, maak een kleurwisseling
		Vector colorVector = new Vector();
		colorVector.add(new java.awt.Point(-1, oldColour));
		colorVector.add(new java.awt.Point(-1, newColour));
		drawing.add(colorVector);
		return(newColour);
	}

	/* bevat(woord), bevatOp(woord)
	 * Gebruikt de globale variabele 'tekst', die hetzelfde is als de meegegeven string.
	 * bevat() retourneert true als een woord in de invoer zit.
	 * bevatOp() retourneert de index van het woord, om de onderlinge positie van twee
	 * woorden te kunnen gebruiken.
	 */
	public static boolean bevat(String woord) {
		if (tekst.indexOf(woord) >= 0)
			return(true);
		return(false);
	}

	public static int bevatOp(String woord) {
		return( tekst.indexOf(woord) );
	}

// Adds a line to the 'drawing'-vector, check boundaries etc.
	public static void addLine(Vector draw, int bx, int by, int ex, int ey, String mode, int res) {
		Tools tools = new Tools();

		// Check boundary restrictions
		// Real-world problem encountered during testing
		if ( bx < 150 ) bx = 150;
		if ( by < 150 ) by = 150;
		if ( ex < 150 ) ex = 150;
		if ( ey < 150 ) ey = 150;
		if ( bx > 600 ) bx = 600;
		if ( by > 400 ) by = 400;
		if ( ex > 600 ) ex = 600;
		if ( ey > 400 ) ey = 400;

		// Add the line to the Vector
		draw.add(tools.draw( new java.awt.Point(bx,by), 
					new java.awt.Point(ex,ey), mode, res ));
	}

// Allow doubles to be given, instead of integers
	public static void addLine(Vector draw, double bx, double by, double ex, double ey, String mode, int res) {
		addLine(draw, (int)bx, (int)by, (int)ex, (int)ey, mode, res);
	}


// Shape methods

// Shape methods kunnen aangeroepen worden met een offset (loc) een mode (we gebruiken
// nu alleen "Line") en een resolutie. De resolutie bepaalt de grofheid van de tekening.
	public static void drawHappy(Vector drawing, double loc, String mode, int resolution) {
		if( loc == 0 ) loc = Math.random();
		for(int i = 0; i < 7; i++) {
			addLine(drawing,500*loc,500*loc,510*loc,510*loc,mode,resolution);
			addLine(drawing,510*loc,510*loc,510*loc,530*loc,mode,resolution);
			addLine(drawing,510*loc,530*loc,500*loc,540*loc,mode,resolution);
			addLine(drawing,500*loc,540*loc,520*loc,540*loc,mode,resolution);
			addLine(drawing,520*loc,540*loc,530*loc,530*loc,mode,resolution);
			addLine(drawing,530*loc,530*loc,530*loc,510*loc,mode,resolution);
			addLine(drawing,530*loc,510*loc,510*loc,500*loc,mode,resolution);
			loc = Math.random();
		}
	}

	public static void drawHeart(Vector drawing, double loc, String mode, int resolution) {
		if (loc == 0) loc = Math.random() * 100;

		addLine(drawing,300+loc,200+loc,250+loc,250+loc,mode,resolution);
		addLine(drawing,250+loc,250+loc,235+loc,270+loc,mode,resolution);
		addLine(drawing,235+loc,270+loc,235+loc,290+loc,mode,resolution);
		addLine(drawing,235+loc,290+loc,250+loc,300+loc,mode,resolution);
		addLine(drawing,250+loc,300+loc,275+loc,300+loc,mode,resolution);
		addLine(drawing,275+loc,300+loc,300+loc,275+loc,mode,resolution);
		addLine(drawing,300+loc,275+loc,325+loc,300+loc,mode,resolution);
		addLine(drawing,325+loc,300+loc,350+loc,300+loc,mode,resolution);
		addLine(drawing,350+loc,300+loc,365+loc,290+loc,mode,resolution);
		addLine(drawing,365+loc,290+loc,365+loc,270+loc,mode,resolution);
		addLine(drawing,365+loc,270+loc,350+loc,250+loc,mode,resolution);
		addLine(drawing,350+loc,250+loc,300+loc,200+loc,mode,resolution);
		}

	public static void drawAngry(Vector drawing, double loc, String mode, int resolution) {
		if( loc == 0 ) loc = Math.random();

		addLine(drawing,250*loc,250*loc,800*loc,800*loc,mode,resolution);
		addLine(drawing,450*loc,800*loc,350*loc,750*loc,mode,resolution);
		addLine(drawing,350*loc,750*loc,650*loc,600*loc,mode,resolution);
		addLine(drawing,250*loc,700*loc,800*loc,400*loc,mode,resolution);
		addLine(drawing,200*loc,600*loc,300*loc,200*loc,mode,resolution);
		addLine(drawing,700*loc,800*loc,200*loc,300*loc,mode,resolution);
	}

	public static void drawSad(Vector drawing, double loc, String mode, int resolution) {
		if( loc == 0 ) loc = ( Math.random() - 0.5) * 100 - 200;

		addLine(drawing,400-loc,400-loc,405-loc,405-loc,mode,resolution);
		addLine(drawing,401+loc,399+loc,388+loc,403+loc,mode,resolution);
		addLine(drawing,406-loc,416+loc,411-loc,415+loc,mode,resolution);
		addLine(drawing,390-loc,405+loc,397-loc,407+loc,mode,resolution);
		addLine(drawing,399-loc,402+loc,402-loc,389+loc,mode,resolution);
		addLine(drawing,403+loc,384+loc,398+loc,385+loc,mode,resolution);
		addLine(drawing,412-loc,397+loc,407-loc,391+loc,mode,resolution);
		addLine(drawing,386+loc,391+loc,387+loc,388+loc,mode,resolution);
		addLine(drawing,402-loc,408+loc,411-loc,403+loc,mode,resolution);
		addLine(drawing,394+loc,394+loc,400+loc,400+loc,mode,resolution);
		addLine(drawing,394-loc,402+loc,396-loc,393+loc,mode,resolution);
		addLine(drawing,422+loc,405+loc,417+loc,399+loc,mode,resolution);

	}

	public static void drawQuestion(Vector drawing, double loc, String mode, int resolution) {
		if( loc == 0 ) loc = Math.random() * 200 - 200;

		addLine(drawing,420+loc,250,400+loc,260,mode,resolution);
		addLine(drawing,400+loc,260,380+loc,250,mode,resolution);
		addLine(drawing,380+loc,250,380+loc,230,mode,resolution);
		addLine(drawing,380+loc,230,400+loc,220,mode,resolution);
		addLine(drawing,400+loc,220,400+loc,200,mode,resolution);
		addLine(drawing,405+loc,180,400+loc,175,mode,resolution);
		addLine(drawing,400+loc,175,395+loc,180,mode,resolution);
		addLine(drawing,395+loc,180,400+loc,185,mode,resolution);
		addLine(drawing,400+loc,185,405+loc,180,mode,resolution);

	}

	public static void drawNonsense(Vector drawing, double loc, String mode, int resolution) {
		if ( loc == 0) loc = Math.random() * 200;
	
		addLine(drawing,300+loc,100,330+loc,130,mode,resolution);
		addLine(drawing,330+loc,130,300+loc,160,mode,resolution);
		addLine(drawing,300+loc,160,330+loc,190,mode,resolution);
		addLine(drawing,330+loc,190,300+loc,220,mode,resolution);
		addLine(drawing,300+loc,220,330+loc,250,mode,resolution);
		addLine(drawing,330+loc,250,300+loc,280,mode,resolution);
		addLine(drawing,300+loc,280,330+loc,310,mode,resolution);
		addLine(drawing,330+loc,310,300+loc,340,mode,resolution);
		addLine(drawing,300+loc,340,330+loc,370,mode,resolution);
	}


// Einde class ColourSpace
}
