import java.util.*;
import java.io.*;
import java.lang.*;

class Convert {
    private static double OPEN_GRIP=18;
    private static double CLOSED_GRIP=0;
	private static double TABLET_HEIGHT = 0;
	private static int DRAW_HEIGHT = 90;
	private static int IN_FRONT_OF_PEN = 420;
	private static int AT_PEN = 456;
	private static int PEN_HEIGHT = 90;
	private static int DROP_PEN_HEIGHT = 85;
	private static int SAFE_HEIGHT = 110;
	private static int HIGH_PEN_HEIGHT = 130;
	private static int BASE_X = 0;
	private static int BASE_Y = 150;
	static IK InverseKinematics = new IK();
  
	public static void toRobot(Vector actions){
		Vector cartesian = actionsToCartesian(actions);
		InverseKinematics.cartesianToJoints(cartesian);
	}

	private static void getPen(Vector v, boolean get, int pen) {
		pen *= 30; // 30 is the distance between two pens. Change this if pen-distance changes
				// (ie. the fourth pen is 4*30=120 to the right)
		pen -= 40; // 40 is the offset (- for left), meaning the black pen is 40 left of the middle..
				// ..(when facing the robot arm)
		System.out.println("PEN : "+pen);
		if(get) {
// Codefix, het wegzetten van een pen gebeurt nu in volgorde (ipv. altijd op 0-4).
			v.add(new GripperPosition(new Point(pen,IN_FRONT_OF_PEN,PEN_HEIGHT), 0, OPEN_GRIP));
			v.add(new GripperPosition(new Point(pen,AT_PEN,PEN_HEIGHT), 0, OPEN_GRIP));
			v.add(new GripperPosition(new Point(pen,AT_PEN,PEN_HEIGHT), 0, CLOSED_GRIP));
			v.add(new GripperPosition(new Point(pen,AT_PEN,HIGH_PEN_HEIGHT), 0, CLOSED_GRIP));
//			v.add(new GripperPosition(new Point(pen,IN_FRONT_OF_PEN,SAFE_HEIGHT), 0, CLOSED_GRIP));
// De pen raakte steeds het bordje, wordt nu iets hoger gehouden
			v.add(new GripperPosition(new Point(pen,IN_FRONT_OF_PEN,HIGH_PEN_HEIGHT), 0, CLOSED_GRIP));

		} else {
			v.add(new GripperPosition(new Point(pen,IN_FRONT_OF_PEN,HIGH_PEN_HEIGHT), 0, CLOSED_GRIP));
			v.add(new GripperPosition(new Point(pen,AT_PEN,HIGH_PEN_HEIGHT), 0, CLOSED_GRIP));
			v.add(new GripperPosition(new Point(pen,AT_PEN,DROP_PEN_HEIGHT), 0, CLOSED_GRIP));
			v.add(new GripperPosition(new Point(pen,AT_PEN,DROP_PEN_HEIGHT), 0, OPEN_GRIP));
			v.add(new GripperPosition(new Point(pen,IN_FRONT_OF_PEN,DROP_PEN_HEIGHT), 0, OPEN_GRIP));
		}
		
	}
	
	public static Vector actionsToCartesian(Vector actions)
	{
		Vector cartesian = new Vector();
		for(int i = 0; i < actions.size(); i++){
			System.out.println("Vector: " + i);
			Vector v = (Vector) actions.get(i);
			for(int j = 0; j < v.size(); j++) {
				java.awt.Point checkColor = (java.awt.Point) v.get(j);
				if(checkColor.x == -1 && j == 0) {
					java.awt.Point oldColor = (java.awt.Point) v.get(0);
					java.awt.Point newColor = (java.awt.Point) v.get(1);
// Initialisatie, nog geen pen wegzetten
					if (oldColor.y != 9) {
						getPen(cartesian, false, oldColor.y);
						System.out.println("Put old pencil back");
					}
					getPen(cartesian, true, newColor.y);
// Codefix, else zonder nieuwe if, voerde (checkColor.x = -1 && j == 1) uit, wat niet moet
				} else if (checkColor.x != -1) {
					if(j == 0) {
						System.out.println("Adding Safe height before");
						cartesian.add(toCartesian((java.awt.Point) v.firstElement(), SAFE_HEIGHT));
					}
					
					cartesian.add(toCartesian((java.awt.Point) v.get(j), DRAW_HEIGHT));
					
					if(j == v.size()-1) {
						System.out.println("Adding Safe height after");
						cartesian.add(toCartesian((java.awt.Point) v.lastElement(), SAFE_HEIGHT));
					}
				}
			}
		}
		return cartesian;
	}

	public static GripperPosition toCartesian(java.awt.Point p, int height)
	{
		Point point = new Point ();
    
		point.x = BASE_X + p.x / 3;
		point.y = BASE_Y + p.y / 3;
		point.z = TABLET_HEIGHT + height;
		GripperPosition result = new GripperPosition(point,0,CLOSED_GRIP);
		return result;
	
	}
}
