import java.util.*;
import java.awt.*;
import java.io.*;

public class Tools {

	public Vector draw(java.awt.Point a, java.awt.Point b, String mode, double res) {
		Vector output = new Vector();
		
		if (mode == "Line")		return pLine(a, b, res);
		if (mode == "Rectangle")return pRect(a, b, res);
		if (mode == "Square")	return pSquare(a, b, res);
		if (mode == "Oval")		return pOval(a, b, res);
		if (mode == "Circle")	return pCircle(a, b, res);
		return output;
	}
	
	private Vector pLine(java.awt.Point a, java.awt.Point b, double res) {
		Vector output = new Vector();
		res *=3;
		int xDist = b.x-a.x;
		int yDist = b.y-a.y;
		double distance = Math.sqrt(Math.pow(xDist,2)+Math.pow(yDist,2));
		double steps = distance/res;
		int x = 0, y = 0;
		for(int i = 0; i < steps; i++) {
			x = a.x + (int) (xDist / steps * i);
			y = a.y + (int) (yDist / steps * i);
			output.add(new java.awt.Point(x, y));
		}
		if(x != b.x || y != b.y)
			output.add(new java.awt.Point(b.x, b.y));
		
		return output;
	}
	private  Vector pRect(java.awt.Point a, java.awt.Point b, double res) {
		Vector output = new Vector();
		Vector line = new Vector();
		
		line = (Vector) pLine(new java.awt.Point(a.x,a.y), new java.awt.Point(b.x,a.y), res);
		for(int i = 0; i < line.size(); i++)
			output.add(line.get(i));
		
		line = (Vector) pLine(new java.awt.Point(b.x,a.y), new java.awt.Point(b.x,b.y), res);
		for(int i = 0; i < line.size(); i++)
			output.add(line.get(i));

		line = (Vector) pLine(new java.awt.Point(b.x,b.y), new java.awt.Point(a.x,b.y), res);
		for(int i = 0; i < line.size(); i++)
			output.add(line.get(i));

		line = (Vector) pLine(new java.awt.Point(a.x,b.y), new java.awt.Point(a.x,a.y), res);
		for(int i = 0; i < line.size(); i++)
			output.add(line.get(i));

		return output;
	}
	private  Vector pSquare(java.awt.Point a, java.awt.Point b, double res) {
		Vector output = new Vector();
		
		int xDist = b.x-a.x;
		int yDist = b.y-a.y;
		
		int minDist = yDist;
		if (Math.abs(xDist) < Math.abs(yDist))
			minDist = xDist;
		
		if(xDist < 0)
			b.x = a.x - Math.abs(minDist);
		else
			b.x = a.x + Math.abs(minDist);
		
		if(yDist < 0)
			b.y = a.y - Math.abs(minDist);
		else
			b.y = a.y + Math.abs(minDist);
			
		output = pRect(a, b, res);
		
		return output;
	}
	
	private  Vector pOval(java.awt.Point a, java.awt.Point b, double res) {
		Vector output = new Vector();
		
		res *=3;
		double d = (Math.abs(b.x-a.x) + Math.abs(b.y-a.y)) / 2;
		double distance = Math.PI * d / res;

		int xDist = b.x-a.x;
		int yDist = b.y-a.y;
		double steps = distance/res;
		int x = 0, y = 0;
		for(double i = 0; i < 2 * Math.PI; i += (2 * Math.PI) / steps) {
			x = a.x + (int) (xDist / 2) + (int) (Math.sin(i) * xDist / 2);
			y = a.y + (int) (yDist / 2) + (int) (Math.cos(i) * yDist / 2);
			output.add(new java.awt.Point(x, y));
		}
		x = a.x + (int) (xDist / 2) ;
		y = a.y + (int) yDist;
		output.add(new java.awt.Point(x, y));
		
		return output;
	}

	private  Vector pCircle(java.awt.Point a, java.awt.Point b, double res) {
		Vector output = new Vector();
		
		int xDist = b.x-a.x;
		int yDist = b.y-a.y;
		
		int minDist = yDist;
		if (Math.abs(xDist) < Math.abs(yDist))
			minDist = xDist;
		
		if(xDist < 0)
			b.x = a.x - Math.abs(minDist);
		else
			b.x = a.x + Math.abs(minDist);
		
		if(yDist < 0)
			b.y = a.y - Math.abs(minDist);
		else
			b.y = a.y + Math.abs(minDist);
			
		output = pOval(a, b, res);
		
		return output;
	}

}
